/*
 * Copyright © 2015 Robert Bosch Car Multimedia GmbH
 *
 * SPDX-License-Identifier: MPL-2.0
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */


#include "didcot-internal.h"
#include "barkway.h"

static void popup_service_proxy_clb( GObject *source_object, GAsyncResult *res,gpointer user_data)
{
 GError *error=NULL;
 DIDCOT_DEBUG("enter");
 data_struct.popup_proxy=barkway_service_proxy_new_finish (res,&error);

  if (error)
    {
      DIDCOT_WARNING ("%s: code %d: %s", g_quark_to_string (error->domain),
                     error->code, error->message);
      g_error_free (error);
    }

}

static void name_appeared (GDBusConnection *connection,
               	   	   	   const gchar     *name,
               	   	   	   const gchar     *name_owner,
               	   	   	   gpointer         user_data)
{
  DIDCOT_DEBUG("enter");

  barkway_service_proxy_new( connection,
                                  G_DBUS_PROXY_FLAGS_NONE,
                                  "org.apertis.Barkway",
                                  "/org/apertis/Barkway/Service",
                                  NULL,
                                  popup_service_proxy_clb,
                                  NULL);

}

static void
name_vanished(GDBusConnection *connection,
               const gchar     *name,
               gpointer         user_data)
{
  DIDCOT_DEBUG("enter");
}

void
popup_client_handler_init (void)
{
  /* Starts watching name on the bus specified by bus_type */
  /* calls name_appeared_handler and name_vanished_handler when the name is known to have a owner or known to lose its owner */
  g_bus_watch_name (G_BUS_TYPE_SESSION,
                    "org.apertis.Barkway",
                    G_BUS_NAME_WATCHER_FLAGS_AUTO_START,
                    name_appeared,
                    name_vanished,
                    NULL,
                    NULL);
}
